package com.xhkjedu.sapi.controller.appversion;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.sapi.model.appversion.TAppTeacherlive;
import com.xhkjedu.sapi.service.appversion.AppTeacherliveService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import com.xhkjedu.sapi.vo.appversion.AppversionVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author ywx
 * @classname AppTeacherliveController
 * @description
 * @date 2021/1/26 11:23
 **/
@RestController
@RequestMapping("/apppc")
public class AppTeacherliveController {
    @Resource
    private AppTeacherliveService appTeacherliveService;

    @PostMapping("/add")
    public ResultVo add(@RequestBody TAppTeacherlive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionname(),"版本名称",2,
                appclient.getVersioncode(),"版本号",2,appclient.getVersionpath(),"应用文件",2});
        Integer id = appTeacherliveService.save(appclient);
        return new ResultVo(0, "保存成功",id);
    }

    @PostMapping("/delete")
    public ResultVo delete(@RequestBody TAppTeacherlive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appTeacherliveService.deleteById(appclient.getVersionid());
        return new ResultVo(0,"删除成功");
    }

    @PostMapping("/update")
    public ResultVo update(@RequestBody TAppTeacherlive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appTeacherliveService.update(appclient);
        return new ResultVo(0,"修改成功");
    }

    @PostMapping("/detail")
    public ResultVo detail(@RequestBody TAppTeacherlive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        TAppTeacherlive client = appTeacherliveService.findById(appclient.getVersionid());
        return new ResultVo(0,"获取详情成功",client);
    }

    @PostMapping("/list")
    public ResultVo list(@RequestBody TAppTeacherlive appclient) {
        PageHelper.startPage(appclient.getPage(), appclient.getPageSize());
        List<AppversionVo> list = appTeacherliveService.listAll();
        PageResult pageResult = PageUtil.getPageResult(new PageInfo(list));
        return new ResultVo(0,"获取app版本列表成功",pageResult);
    }

    @PostMapping("/get_new")
    public ResultVo getNew() {
        TAppTeacherlive appclient = appTeacherliveService.getNew();
        return new ResultVo(0,"获取最新app版本成功",appclient);
    }
}
